;; c:/games/abuse200/addon/bnna/bnna.lsp
/*
;; **************************************************************************
;; LISP Startup/Readme File for Banana v0.71 by Steven Chan, IRQ Design
;;
;;
;;                                                     III IIII   III
;;                                                      I  I   I I   I
;;                                                      I  IIII  I   I
;;                                                      I  I  I  I  I 
;;                                                     III I   I  II I
;;
;; IRQ DESIGN
;;  >   http://home.earthlink.net/~lluivf/HTM/irq01.htm
;;
;;  Treering 1 is a group of students that attend at Cope Middle School in
;;  the Inland Empire of Southern California. Treering 1 is where we eat our
;;  lunches on school days. It's a, well, concrete ring around a tree. IRQ
;;  design has only two people in it so far.
;;
;; CREDITS
;;   Programmer ....................... Steven Chan
;;   Art .............................. Steven Chan
;;                                      Coconut Monkey
;;   Sound ............................ Bobby Prince
;;                                      Coconut Monkey
;;   The Beta Team .................... Steven Chan
;;
;;  Crack dot Com is:
;;   Initial game engine .............. Jonathan Clark
;;   Initial game art ................. Duong Nguyen, Murray Mcmillan
;;   Initial game sound ............... Bobby Prince
;;
;;  Special thanks to ................ Jonathan Clark
;;                                     Coconut Monkey
;;                                     Stephanie Wong
;;                                     Mom, Dad, Chris, and Jenn    
;;
;;  Coconut Monkey? He is the receptionist of PC Gamer (US). Find him
;;  at http://www.pcgamer.com/.
;;
;;
;; SYSTEM REQUIREMENTS
;;  Your system requires the minimum of the following to run this game:
;;   > Abuse v2.00 (English American language)
;;   > 486/SX
;;   > 3.5" Double-sided High-density floppy disk drive
;;   > 8 MB RAM
;;   > Mouse
;;   > 0.5 MB free hard-drive space
;;   > IBM-compatible computer
;;  This game has NOT been tested on UNIX, Macintosh, or SGI ports.
;;
;; INSTALLING
;;  Dos. Users:
;;   1) Insert disk 1 into the disk drive.
;;   2) At the disk prompt, run INSTALL and follow the instructions onscreen.
;;      It is extremely important that you follow the instructions or else
;;      the game will not work.
;;
;;  Windows 95 Users:
;;   1) Insert disk 1 into the disk drive.
;;   2) Double-click on "My Computer".
;;   3) Double-click the icon representing the disk drive that the disk is in.
;;   4) Double-click on the file "Install.exe".
;;   5) Follow the instructions onscreen.
;;
;; RUNNING THE PROGRAM
;;  Dos. Users:
;;   1) Go to the Abuse directory.
;;   2) Type the following line and press <ENTER>.
;;      abuse.exe -lsf addon/galx/galx.lsp
;;
;;  Windows 95 Users:
;;   1) Click the Start button.
;;   2) Select "Run".
;;   3) In the space provided type in your Abuse directory followed by:
;;       abuse.exe -lsf addon/galx/galx.lsp
;;      For example: c:\abuse\abuse.exe -lsf addon/galx/galx.lsp
;;
;; PLAYING THE GAME
;;  In this game you must destroy everything you see onscreen. Watch out,
;;  though, enemies may escape and try to fire at you!
;;
;; CONTROL KEYS
;;  f1                  help
;;  esc                 quit
;;  p                   pause
;;
;;  arrowkeys           move monkey
;;
;;  The object of this game is to collect the bananas.
;;
;; ERRORS
;;  If you find any bugs, please let me know so I can attempt a fix. This is
;;  my very second game I've made and so you can bet there'll be some. I've
;;  tried to fix as many as I could. If you also find some room that needs
;;  improvement I'll see if I can implement it in the game code.
;;
;; NEXT TIME
;;  Current and Hot:
;;   - Shootout
;;      shooting gallery fun!
;;   - Lotto Number Generator
;;      lots of luck as this program picks the numbers randomly for you!
;;   - gamecentral
;;      the newsletter dedicated to the games we like! Available now.
;;   - Bash
;;      hammer out Mr. Peterson when he gets you aggravated
;;   - Galaxian
;;      a relatively simple Galaxian-type game
;;   - More Abuse
;;      a complete addon level pack for Abuse, with four levels
;;   - Banana
;;      Simple and stupid monkey game
;;
;;  Next projects planned:
;;   - Deviator
;;      a high-speed fast-paced arcade-action ship-blastin' space game!
;;   - Bloodslingers
;;      A bloody fighting game where you pit against mean guys!
;;   - Bigfoot
;;      You're a big hairy monster that crushes buildings and people.
;;
;; DISCLAIMER AND LEGAL STUFF
;;
;;  - I am not responsible for any bugs or errors (though I try my best to
;;    squish them) that happen to pop up on your computer, nor am I
;;    responsible for anybody's stupidity. Don't try to blame me after
;;    messing up the programming!!
;;
;;  - Abuse (c) 1995, 1996 Crack dot Com. Abuse and Crack dot Com are
;;    trademarks of Crack dot Com.
;;
;;
;; **************************************************************************
*/

;; status:
;;   Complete-    71%
;;   Updated -    6 September 1996



(perm-space)

(setq section 'game_section)              

(setq bnna_dir "addon/bnna/")
(setq bnna_art (concatenate 'string bnna_dir "bnna.spe"))

(setq load_warn nil)
(load "gamma.lsp")
(setq load_warn T)

(load "lisp/english.lsp")
(load "lisp/common.lsp")
(load "lisp/userfuns.lsp")
(load "lisp/input.lsp")

(load_big_font     "art/letters.spe" "letters")
(load_small_font   "art/letters.spe" "small_font")
(load_console_font "art/consfnt.spe" "fnt5x7")
(load_color_filter "art/back/backgrnd.spe")
(load_palette      "art/back/backgrnd.spe")
(load_tiles bnna_art)

(setq title_screen (cons bnna_art "title_screen"))
(setq sell_screens '(("addon/bnna/bnna.spe" . "credit")))
(setq help_screens '("addon/bnna/bnna.spe" "help"))

(setq ic_quit    "Quit Banana"         )   ; various messages
(setq ic_easy    "Difficulty : Senator")
(setq ic_medium  "Difficulty : Easy"   )
(setq ic_hard    "Difficulty : Tougher")
(setq ic_extreme "Difficulty : Unfair" )

/**** define sounds ****/
(def_sound 'BUTTON_PRESS_SND   "sfx/button02.wav")
(def_sound 'YEAH               (concatenate 'string bnna_dir "yeah01.wav"))
(def_sound 'CRASH              (concatenate 'string bnna_dir "crash01.wav"))

(defun sndplay_aifn ()
  (if (or (> (xacel) 127) (< (xacel) 0))
      (set_xacel 100))
  (if (eq (xvel) 0)
      (progn
        (if (eq (aitype) 0)
            (play_sound CRASH (xacel) (x) (y))
          (play_sound YEAH (xacel) (x) (y)))
        (set_xvel (yvel)))
    (set_xvel (- (xvel) 1))) T)

(def_char SNDPLAY
  (funs (ai_fun sndplay_aifn)
        (draw_fun dev_draw))
  (fields ("xvel"   "frames until next play")
          ("yvel"   "delay frames")
          ("aitype" "sound num")
          ("xacel"  "volume (0-127)"))
  (range 500 500)
  (states "art/misc.spe" (stopped "sfx_player")))


/***** thanh_funs *****/
(defun add_score (addscr)
  (with_object (bg) (setq score (+ score addscr))))

(defun get_score ()
  (with_object (bg) score))

(defun thanh_move (xm ym but)
  (next_picture)
  (set_gravity 1)
  (set_shift_down (me) 80)
  (set_shift_right (me) (- 0 (x)))
  (if (or (and (< xm 0) (> (x) 20)) (and (> xm 0) (< (x) 300)))
      (mover xm 0 0)
    0))

(defun thanh_draw ()
  (draw)
  (put_string (get_main_font) (- (view_x2) 80) (view_y1)
              (concatenate 'string "score " (digstr (get_score) 8))
              (find_rgb 255 0 0)))

(def_char THANH
  (vars score score_string)
  (funs (move_fun thanh_move)
        (draw_fun thanh_draw))
  (abilities (walk_top_speed 8)
             (start_accel 8))
  (flags (can_block T))
  (states bnna_art
    (stopped (app (rep "monkey1" 6)
                  (rep "monkey2" 6)))))

/**** respawn_funs *****/
(defun srespawn_aifn ()
  (if (<= (xacel) 1)
      (set_xacel 2))
  (if (eq (total_objects) 0)
      T
    (if (not (eq (total_objects) 2))
        (if (eq (yvel) 0)
            (progn
              (add_object (with_object (get_object 0) (otype))
                          (if (eq (random 2) 0)
                              (- (x) (random (xacel)))
                            (+ (x) (random (xacel)))) (y))
              (set_yvel (xvel)))
          (set_yvel (- (yvel) 1))))) T)

(defun srespawn_draw ()
  (if (edit_mode)
      (progn
        (draw)
        (draw_line (- (x) (xacel)) (y) (+ (x) (xacel)) (y) (find_rgb 10 255 12))
  )))

(def_char SRESPAWN
  (funs (ai_fun   srespawn_aifn)
        (draw_fun srespawn_draw))
  (fields ("yvel"    "frames until next respawn")
          ("xvel"    "frames until one respawn")
          ("xacel"   "respawn x_pos range"))
  (states "art/misc.spe" (stopped "respawn")))

/**** banana_fun ****/
/*
(defun banana_aifn ()
  (setq kill_flag T)
  (set_course 270 10)
  (float_tick)
  (if (touching_bg)
      (progn
        (setq kill_flag nil)
        (play_sound (def_sound "sfx/health01.wav") 80 (x) (y))
        (add_score 300)))
  (if (> (y) 180)
      (setq kill_flag nil))
  kill_flag) */

(defun banana_aifn ()
  (select (aistate)
    (0 (set_course 270 10)
       (float_tick)
       (if (touching_bg)
           (set_aistate 1))
       (if (> (y) 180)
           (set_aistate 2)) T)
    (1 (play_sound (def_sound "sfx/health01.wav") 100 (x) (y))
       (add_score 300) nil)
    (2 (set_fade_count (+ (fade_count) 2))
       (not (>= (fade_count) 15)))))

(def_char BANANA
  (funs (ai_fun   banana_aifn))
  (states bnna_art (stopped "banana")))

/**** start_stuff ****/
(defun stay_ai ()
  T)

(def_char START
  (funs (ai_fun    stay_ai)
        (draw_fun  dev_draw))
  (states bnna_art (stopped "start")))

/**** finalisation ****/
(setq end_msg (concatenate 'string
                "Thank you for trying Banana v0.71.\n\n"
                "* Read ADDON/BNNA/BNNA.LSP for help, information, credits, and dedications.\n\n"
                "* To order the full version of ABUSE from Electronic Arts, please call:\n"
                "  USA       1-800-245-4525\n"
                "  CANADA    604-451-3600\n"
                "  ENGLAND   0753-549442\n"
                "  FRANCE    72 17 07 83\n"
                "  GERMANY   05241 / 24307\n"
                "  AUSTRALIA +61(75)911 388\n"
                "  JAPAN     03-5410-3100\n"
                "  or buy it at your local software retailer. It's worth it.\n\n"
                "* Visit http://home.earthlink.net/~lluivf/HTM/irq01.htm\n\n"))


(create_players THANH)
(set_first_level (concatenate 'string bnna_dir "bnna01.lvl"))
(gc)
(tmp-space)
